CurseBar = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
CurseBar:RegisterChatCommand("/CurseBar", "/cb", nil)

function CurseBar:OnEnable()
    self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function CurseBar:PLAYER_ENTERING_WORLD()
    if CurseBarClassCheck() then
        CurseBarLoad()
    end
end


function CurseBarLoad()
    local width, height, scale = 60, 60, .636
    local CurseBarLastButton = "MultiBarBottomRightButton12"
    
    CurseBarButton1 = CreateFrame("Button", "CurseBarButton1", UIParent, "CurseBarButtonTemplate")
    CurseBarButton2 = CreateFrame("Button", "CurseBarButton2", UIParent, "CurseBarButtonTemplate")
    CurseBarButton3 = CreateFrame("Button", "CurseBarButton3", UIParent, "CurseBarButtonTemplate")
    CurseBarButton4 = CreateFrame("Button", "CurseBarButton4", UIParent, "CurseBarButtonTemplate")
    CurseBarButton5 = CreateFrame("Button", "CurseBarButton5", UIParent, "CurseBarButtonTemplate")
    CurseBarButton6 = CreateFrame("Button", "CurseBarButton6", UIParent, "CurseBarButtonTemplate")
    CurseBarButton7 = CreateFrame("Button", "CurseBarButton7", UIParent, "CurseBarButtonTemplate")
    CurseBarButton8 = CreateFrame("Button", "CurseBarButton8", UIParent, "CurseBarButtonTemplate")
    CurseBarButton9 = CreateFrame("Button", "CurseBarButton9", UIParent, "CurseBarButtonTemplate")
    CurseBarButton10 = CreateFrame("Button", "CurseBarButton10", UIParent, "CurseBarButtonTemplate")
    CurseBarButton11 = CreateFrame("Button", "CurseBarButton11", UIParent, "CurseBarButtonTemplate")
    CurseBarButton12 = CreateFrame("Button", "CurseBarButton12", UIParent, "CurseBarButtonTemplate")

    for i = 1, countEntries(CurseBarSpells) do
        if IsUsableSpell(CurseBarSpells[i]) then
            local button = getglobal("CurseBarButton"..i)
            button:SetWidth(width); button:SetHeight(height); button:SetScale(scale); button:EnableMouse(true)
            
            if (i == 1) then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            elseif (CurseBarLastButton == "MultiBarBottomRightButton12") then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            else
                button:SetPoint("CENTER", CurseBarLastButton, "LEFT", -36, 0)
            end
            
            button:SetAttribute("type", "spell")
            button:SetAttribute("spell", CurseBarSpells[i])

            button:SetScript("OnLeave", function() GameTooltip:Hide() end)
            button:SetScript("OnEnter", function()
                GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
                GameTooltip:SetSpell(CurseBar_GetSpellID(CurseBarSpells[i]))
                GameTooltip:Show()
            end)

            local t = button:CreateTexture(nil,"BACKGROUND")
                t:SetTexture(GetSpellTexture(CurseBarSpells[i]))
                t:SetAllPoints(button)
                button.texture = t
            
            CurseBarLastButton = button
        end
    end
end

-- UPDATE COOLDOWN
function CurseBar:SPELL_UPDATE_COOLDOWN()
    if CurseBarClassCheck() then
        for i = 1, countEntries(CurseBarSpells) do
            if (GetSpellCooldown(CurseBarSpells[i]) ~= nil and GetSpellCooldown(CurseBarSpells[i]) > 0) then
                local start, duration, enable = GetSpellCooldown(CurseBarSpells[i])
                getglobal("CurseBarButton".. i .."Cooldown"):SetCooldown(start, duration)
            end
        end
    end
end

-- RETURN CLASS
function CurseBarClassCheck()
    local _, class = UnitClass("player")
    if class == "WARLOCK" then return true else return false end
end

-- FIND HIGHEST SPELL RANK
function CurseBar_GetSpellID(spell, rank)
	local i = 1
	local spellID
	local highestRank
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			break
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i
				end
			else
				spellID = i
				highestRank = spellRank
			end
		end
		i = i + 1
		if (i > 250) then
			break
		end
	end			
	return spellID, highestRank
end

-- COUNT TOTAL ENTRIES IN A TABLE
function countEntries(tbl)
    local cnt = 0;
    for k in pairs(tbl) do cnt = cnt + 1; end
    return cnt
end